﻿using ProjectGasMachine.Entities;

namespace ProjectGasMachine.Drawnings;
/// <summary>
/// 
/// </summary>
public class DrawningGasMachine : DrawningMachine
{
    
    
    /// <summary>
    /// конструктор
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес машины</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="gas">Признак наличия бака для бензина</param>
    /// <param name="beacon">Признак наличия маяка</param>

    public DrawningGasMachine(int speed, double weight, Color bodyColor, Color additionalColor, bool gas, bool beacon) : base(115, 70)
    {
        EntityGas = new EntityMachine(speed, weight, bodyColor, additionalColor, gas, beacon);
    }


    public override void DrawTransport(Graphics g)
    {
        if (EntityGas == null || EntityGas is not EntityMachine gasmachine || !_startPosX.HasValue || !_startPosY.HasValue)
        {
            return;
        }

        Pen pen = new(Color.Black);
        Brush additionalBrush = new SolidBrush(gasmachine.AdditionalColor);


        //маяк сигнальный
        if (gasmachine.Beacon)
        {
            g.DrawRectangle(pen, _startPosX.Value + 95, _startPosY.Value, 10, 10);
            g.FillRectangle(additionalBrush, _startPosX.Value + 95, _startPosY.Value, 10, 10);
        }

        //бак с газом
        if (gasmachine.Gas)
        {
            g.DrawEllipse(pen, _startPosX.Value, _startPosY.Value + 10, 80, 30);

            g.FillEllipse(additionalBrush, _startPosX.Value, _startPosY.Value + 10, 80, 30);
        }

        _startPosX += 5;

        base.DrawTransport(g);

        _startPosX -= 5;

    }
    
}
