﻿namespace ProjectGasMachine.Entities;
/// <summary>
/// Класс-сущность "бензовоз"
/// </summary>
public class EntityMachine : EntityGas
{
    
    public Color AdditionalColor { get; private set; }
    /// <summary>
    /// Признак (опция) наличия бака для бензина
    /// </summary>
    public bool Gas { get; private set; }
    /// <summary>
    /// Признак (опция) наличия маяка
    /// </summary>
    public bool Beacon { get; private set; }
    /// <summary>
    /// 
    /// </summary>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="gas">Признак наличия бака для бензина</param>
    /// <param name="beacon">Признак наличия маяка</param>

    public EntityMachine(int speed, double weight, Color bodyColor, Color additionalColor, bool gas, bool beacon) : base(speed, weight, bodyColor)
    {
        AdditionalColor = additionalColor;
        Gas = gas;
        Beacon = beacon;
    }
}
