﻿namespace ProjectGasMachine.MovementStrategy;
/// <summary>
/// интерфейс для работы с перемещаемым объектом
/// </summary>
public interface IMoveableObjects
{
    /// <summary>
    /// получение координаты объекта
    /// </summary>
    ObjectParameters? GetObjectPosition { get; }

    /// <summary>
    /// шаг объекта
    /// </summary>
    int GetStep { get; }

    /// <summary>
    /// попытка переместить объект в указанном направлении
    /// </summary>
    /// <param name="direction"></param>
    /// <returns>true - объект перемещен, false - перемещение невозможно</returns>
    bool TryMoveObject(MovementDirection direction);

}
