﻿namespace ProjectGasMachine.MovementStrategy;

public class ObjectParameters
{
    /// <summary>
    /// координата x
    /// </summary>
    private readonly int _x;

    /// <summary>
    /// координата y
    /// </summary>
    private readonly int _y;

    /// <summary>
    /// ширина объекта
    /// </summary>
    private readonly int _width;

    /// <summary>
    /// высота объекта
    /// </summary>
    private readonly int _height;

    /// <summary>
    /// левая граница
    /// </summary>
    public int LeftBorder => _x;


    /// <summary>
    /// верхняя граница
    /// </summary>
    public int TopBorder => _y;


    /// <summary>
    /// правая граница
    /// </summary>
    public int RightBorder => _x + _width;


    /// <summary>
    /// нижняя граница
    /// </summary>
    public int DownBorder => _y + _height;

    /// <summary>
    /// середина объекта
    /// </summary>
    public int ObjectMiddleHorizontal => _x + _width/2;

    /// <summary>
    /// середина объекта
    /// </summary>
    public int ObjectMiddleVertical => _y + _height / 2;

    /// <summary>
    /// конструктор
    /// </summary>
    /// <param name="x">координата x</param>
    /// <param name="y">координата y</param>
    /// <param name="width">ширина объекта</param>
    /// <param name="height">высота объекта</param>
    public ObjectParameters(int x, int y, int width, int height)
    {
        _x = x;
        _y = y;
        _width = width;
        _height = height;
    }
}
